# Run postgres locally
```
docker run --name postgres -e POSTGRES_PASSWORD=postgres -d -p 5432:5432 postgres
```

Run test for Postgres locally
```
UB_DBA=postgres UB_DBAPWD=postgres UB_DB_DRIVER=PostgreSQL UB_APP=autotest  PLATFORM=lin ./tsql3.sh
```

Run autotest app in debug mode after tests
```
UB_DBA=postgres UB_DBAPWD=postgres UB_DB_DRIVER=PostgreSQL UB_APP=autotest  PLATFORM=lin ub -cd -dev
```



# Run SQL Server locally
```shell
docker run --name sqlserver19 -e "ACCEPT_EULA=Y" -e "MSSQL_SA_PASSWORD=UBtestSaPwd12" -p 1433:1433 -d mcr.microsoft.com/mssql/server:2019-CU14-ubuntu-20.04
```

Run tests for SQL Server locally
- Once - add a section to ~/.odbc.ini
```ini
[ub5_autotest_mssql]
Driver=ODBC Driver 18 for SQL Server
Description=Linux autotest
Trace=No
#Server=tcp:ms16.unitybase.info,1433
Server=tcp:localhost,1403
Database=master
KeepAlive=10
Encrypt=no
```

```shell
UB_DBA=sa UB_DBAPWD=UBtestSaPwd12 UB_DB_DRIVER=MSSQLODBC UB_APP=autotest PLATFORM=lin ./tsql3.sh
```

Run UB serer after autotest creates and fill database

```shell
UB_DB_DRIVER=MSSQLODBC UB_APP=autotest  PLATFORM=lin ub -cd -dev
```

# Run Oracle locally

To build a docker image follow 
https://blogs.oracle.com/connect/post/deliver-oracle-database-18c-express-edition-in-containers
or
https://github.com/oracle/docker-images/blob/main/OracleDatabase/SingleInstance/README.md

> **WARNING** Oracle XE database size is limited to 12G

Run Oracle locally
Make a data folder (replace pavelmash with your user name)
```
mkdir -p /home/pavelmash/dockerVolumes/myxedb/oradata
chown 54321:54321 /home/pavelmash/dockerVolumes/myxedb/oradata
```
and run an Oracle container

```
docker run --name oracle18_4 \
    -d \
    -p 1521:1521 \
    -p 5500:5500 \
    -e ORACLE_PWD=Ora1Pwd_12 \
    -e ORACLE_CHARACTERSET=AL32UTF8 \
    -v /home/pavelmash/dockerVolumes/myxedb/oradata:/opt/oracle/oradata \
    oracle/database:18.4.0-xe
```

Enter container and import DB dmp
```shell
docker exec -it --user=oracle oracle18_4 bash
```



