const UB = require('@unitybase/ub')
const Session = UB.Session

const assert = require('assert')
const _ = require('lodash')

/**
 *
 */
function testTUBDataStoreMethodWithResult () {
  const STORE = UB.DataStore('tst_service')
  const res = STORE.runWithResult('multiply', { a: 3, b: 10 })
  assert.strictEqual(res.multiplyResult, 30, 'store.runWithResult("multiply", {a:3,b:10}) should return 30 in res.multiplyResult but got res=' + JSON.stringify(res))
}

(function () {
  const res = { success: true }
  try {
    testTUBDataStoreMethodWithResult()
  } catch (e) {
    res.success = false
    res.reason = e.message + ' Stack: ' + e.stack
  }
  module.exports = res
  return res
})()
