module.exports.finalize = finalize
/**
 * For testing purpose remove UBA_ROLE_SELECT_USER (uba_role.select for User) ELS rule
 * For historical reaso /uba/_autotest/010_testELS.js expect User role do not have initial permission for uba_role.select
 * @param {SyncConnection} conn
 * @param {Object<string, DBConnection>} dbConnections
 * @param {Object} dbVersions
 * @param {{hooks: Array<{model: string, hook: Object<string, function>}>, files: Array<{model: string, name: string, fullPath: string, sha: string}>}} migrations
 */
function finalize ({ conn, dbConnections, dbVersions, migrations }) {
  dbConnections.main.exec('delete from uba_els where code = ?', ['UBA_ROLE_SELECT_USER'])
  dbConnections.main.commit() // manual commit; execSql will commit automatically
}
