This documentation describes visual components bundled into `@unitybase/adminui-vue` package.

All components are already registered using `Vue.component`, so can be used without any additional steps.

Documentation is separated into groups:
  - **layout**: components and options for laying out your forms (responsive)
  - **presentational**:  components what can be used without UnityBase server
  - **data-aware**:  components what uses a knowledge about UnityBase metadata to configure itself depending on Domain
  - **views**: `smart components` such as forms etc. (todo)
 - **tutorials**: complex examples for most common UI tasks

> All code blocks are editable and reactive - just change something and see result immediately

> Server-side data is read-only for demo user

Data-aware components use the following metadata:

![req_model_er_diagram](img/req_model_er_diagram.png)

> ER diagram above is created using Administrator->UI->ER diagrams adminUI shortcut



