UFileCollection extends UFileMultiple, so it has same props, slots etc.
But it maps to the collection items by collection name

### Usage
```vue
<template>
<u-file-collection
  collection-name="attachments"
  file-attribute="photo"
  subject-attribute="request"
  entity-name="req_attachment"
  :remove-default-buttons="['add']"
/>
</template>
```

### Editing of active row inside the `activeRowSidebar`
```vue
<template>
<u-file-collection
  collection-name="attachments"
  file-attribute="photo"
  subject-attribute="request"
  entity-name="req_attachment"
  view-mode="carouselWithPreview"
  sidebar-position="left"
>
  <template #activeRowSidebar="{data, setData}">
    <u-form-row label="req_attachment.photoKind">
      <u-select-enum
        :value="data.enumValue"
        e-group="REQ_PHOTO_KIND"
        @input="setData('enumValue', $event)"
      />
    </u-form-row>
    <u-form-row label="req_attachment.notes">
      <u-base-input
        :value="data.notes"
        @input="setData('notes', $event)"
      />
    </u-form-row>
  </template>
</u-file-collection>
</template>
```

In example above collection `attachments` is defined as:
```
/*
Form({
  entity: 'req_request',
  instanceID: this._firstReqID
}).processing({
  collections: {
    attachments: ({ state }) => UB.Repository('req_attachment')
      .attrs('ID', 'photo', 'request', 'notes', 'photoKind')
      .where('request', '=', state.data.ID)
  }
})
*/
```