### Show image, when clicking on image - show it's full-screen preview

```vue
<u-image-viewer
  style="width: 100px; heigth: 100px"
  imageUrl="https://upload.wikimedia.org/wikipedia/commons/3/3f/Stamp_of_Ukraine_s1985.jpg"
  fileName="FckRussianWarship.png"
/>
```

### Do not show an image - only preview

```vue
<template>
  <div>
    <u-button @click="previewVisible=true">Click to see what happens</u-button>
    <u-image-viewer
      v-if="previewVisible"
      style="width: 100px; heigth: 100px"
      image-is-hidden
      imageUrl="https://upload.wikimedia.org/wikipedia/commons/a/af/%D0%9A%D0%BE%D0%BD%D0%B2%D0%B5%D1%80%D1%82_%C2%AB%D0%A0%D1%83%D1%81%D1%81%D0%BA%D1%96%D0%B9_%D0%B2%D0%BE%D1%94%D0%BD%D0%BD%D0%B8%D0%B9_%D0%BA%D0%BE%D1%80%D0%B0%D0%B1%D0%BB%D1%8C%E2%80%A6_%D0%92%D0%A1%D0%AC%D0%9E%21%C2%BB_%D0%B7%D1%96_%D1%81%D0%BF%D0%B5%D1%86%D0%BF%D0%BE%D0%B3%D0%B0%D1%88%D0%B5%D0%BD%D0%BD%D1%8F%D0%BC.png"
      fileName="RussianWarshipDone.png"
      @viewer-hidden="markPreviewAsHidden"
    />
  </div>
</template>
<script>
export default {
  data() {
    return {
      previewVisible: false
    }
  },
  methods: {
    markPreviewAsHidden () {
      this.previewVisible = false
    }
  }
}
</script>
```
