# Change Log
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/)
and this project adheres to [Semantic Versioning](http://semver.org/).

## [Unreleased]
### Added

### Changed

### Deprecated

### Removed

### Fixed

## [5.23.20] - 2023-03-08
## [5.23.19] - 2023-03-01
## [5.23.18] - 2023-02-22
## [5.23.17] - 2023-02-15
### Added
 - new BLOB stores configuration properties:
   - `whitelistExtensions`: array of allowed file extensions (with ., lowercase), example: ['.jpg', '.png']. If empty(default) - any extension is allowed
   - `blacklistExtensions`: array of NOT allowed file extensions (with ., lowercase), example: ['.exe', '.sh']
   Example:
 ```
{
    "name": "simple",
    "path": "/%stores/documents/simple", // default ./ added for test only!
    "isDefault": true,
    "blacklistExtensions": [".exe", ".com", ".bat", ".sh"]
},
{
    "name": "avatars",
    "path": "%UB_APPDATA%stores/documents/avatars",
    "whitelistExtensions": [".png", ".jpg", ".jpeg", ".webp"]
}
```
## [5.23.16] - 2023-02-10
## [5.23.15] - 2023-02-06
## [5.23.14] - 2023-01-11
## [5.23.13] - 2022-12-01
## [5.23.12] - 2022-12-01
## [5.23.11] - 2022-10-21
## [5.23.10] - 2022-10-13
### Added
- Ability to use `skipRls` option in `App.blobStores.getContent` method (server context):
```javascript
App.blobStores.getContent(
    {
      ID: execParams.ID,
      entity: 'dfx_Document',
      attribute: 'docImage'
    },
    {
      encoding: 'utf8',
      skipRls: true
    }
  )
```

## [5.23.9] - 2022-08-19
## [5.23.8] - 2022-08-16
## [5.23.7] - 2022-08-04
## [5.23.6] - 2022-07-28
## [5.23.5] - 2022-07-26
## [5.23.4] - 2022-07-12
### Fixed
 - allow chunked file upload for ub 5.22.11 (not 5.22.0011 because of typo in 5.23.3 ) 

## [5.23.3] - 2022-07-11
### Added
- chunked file upload support (require UB@5.22.11)

## [5.23.2] - 2022-07-05
## [5.23.1] - 2022-06-19
## [5.23.0] - 2022-06-15
## [5.22.9] - 2022-06-01
## [5.22.8] - 2022-05-26
## [5.22.7] - 2022-05-22
### Fixed
 - note in JSDoc what `App.blobStores.putContent` can accept content as Buffer (in addition to ArrayBuffer|String|THTTPRequest) 

## [5.22.6] - 2022-05-04
## [5.22.5] - 2022-04-29
## [5.22.4] - 2022-04-27
## [5.22.3] - 2022-03-25
## [5.22.2] - 2022-01-24
## [5.22.1] - 2022-01-14
## [5.22.0] - 2022-01-09
## [5.20.22] - 2021-12-02
## [5.20.21] - 2021-11-30
## [5.20.20] - 2021-11-23
### Added
- `internalWriteDocumentToResp` now has optional additional parameter `skipRls`.  Must be used with care!  Caller of
  the method is responsible for security checks.

## [5.20.19] - 2021-11-14
## [5.20.18] - 2021-11-05
### Added
 - when multitenancy enabled stored paths will now contain the tenant code

## [5.20.17] - 2021-10-27
## [5.20.16] - 2021-09-24
## [5.20.15] - 2021-09-08
## [5.20.14] - 2021-08-31
## [5.20.13] - 2021-08-18
### Added
 - under Linux BLOB stores operation is measured using prometheus `unitybase_fs_operation_duration_seconds` histogram
   (starting from UB server 5.20.4).

## [5.20.12] - 2021-07-08
## [5.20.11] - 2021-06-14
## [5.20.10] - 2021-05-24
## [5.20.9] - 2021-05-13
## [5.20.8] - 2021-04-24
## [5.20.7] - 2021-04-22
## [5.20.6] - 2021-04-16
## [5.20.5] - 2021-04-13
## [5.20.4] - 2021-04-02
## [5.20.3] - 2021-04-01
### Fixed
 - UB<5 regression: fix `Path must be a string` error in case caller do not pass `fileName` in setDocument request (as UB<5 client can do) 
 - `blobStores.fillResponse` returns `true` instead of `undefined` in case file successfully scheduled to send 

## [5.20.2] - 2021-03-30
## [5.20.1] - 2021-03-29
### Added
 - new method `blobStores.internalWriteDocumentToResp` - writes a BLOB content to the response without
   verifying an ALS (but RLS is verified) or return an error without modifying a response.
   Exposed as `App.blobStores.internalWriteDocumentToResp`
   
   **SECURITY** - method can be used inside endpoint or rest entity method, which already checks
   the access rights to the document.
   
### Fixed
 - `App.blobStores.putContent` documentation fixed - content can also be a THTTPRequest (since UB@5.9.3)

## [5.20.0] - 2021-03-25
## [5.19.6] - 2021-03-23
### Added
 - history rotation adds `entity` and `createdAt` values into `ub_blobHistory`.
   This allows implement a BLOB FTS indexing using external tools (like ElasticSearch etc.)

### Fixed
 - UB4 regression: if BLOB info stored in the DB not contains a `revision` (UB < 5) `getDocument` don't try
   to get a revision from history and returns an actual content

## [5.19.5] - 2021-03-15
### Added
 - **SECURITY**: for **untity**-entity based `getDocument` requests check user have access to the record in both base entity and unity-entity (instead unity-entity only)

### Fixed
 - **SECURITY** filesystem based blob stores checks file name is valid before storing content into the file system

## [5.19.4] - 2021-03-03
## [5.19.3] - 2021-02-10
### Added
  - in case UB is behind nginx `getDocument` endpoint for fileSystemBlobStores adds *x-query-params* header what contains URL parameters. 
    This allows to extend a proxy config with rules what depends on URL parameters.
    
    See example what uses this feature to add an image resize (thumbnails) in [reverse proxy tutorial](https://unitybase.info/api/server-v5/tutorial-reverse_proxy_nginx.html#extending-autogenerated-config)

## [5.19.2] - 2021-02-08
### Fixed
 - `setDocument` endpoint return valid file size for dirty document, based on `fs.statSync()` result  

## [5.19.1] - 2021-02-03
## [5.19.0] - 2021-02-02
### Changed
 - `setDocument` endpoint will use `req.writeToFile` if request body not in base64 instead of reading
   body into JS memory and when write it using fs.writeFileSync.
   This prevents double memory allocation.
 - **BREAKING** `BlobStoreCustom.saveContentToTempStore` method signature changed.
   `content` parameter can be either ArrayBuffer or THTTPRequest.
   Support for `content: THTTPRequest` MUST be added to descendants.
 - use new property `req.parsedParameters` instead of `queryString.parse(req.parameters)`

## [5.5.12] - 2021-01-30
### Changed
 - **BREAKING** `getDocument` endpoint return a BLOB content without `Content-Disposition` header.
  To download a BLOB store content with original file name new method of @unitybase/adminui-pub `$App.downloadDocument`
  should be used. 
   
  For frontends without adminui-pub `download` attribute of `a` HTML element can be used: `<a href=... download="origFileName">`
   
## [5.5.11] - 2021-01-26
## [5.5.10] - 2021-01-19
## [5.5.9] - 2021-01-17
## [5.5.8] - 2020-12-28
### Added
 - BLOB sores: to transform non lun'ed store to LUN'ed old folder MUST be mounted into `blobStoreRoot/LU00`

### Changed
 - hack with UB 1.12 and UB 4.x compatibility for file system BLOB stores with historyDepth = 0 is **REMOVED**.
   Previous implementation is correct.
    
## [5.5.7] - 2020-12-22
## [5.5.6] - 2020-12-21
## [5.5.5] - 2020-12-20
## [5.5.4] - 2020-12-14
### Fixed
 - fixed UB 1.12 and UB 4.x compatibility for file system BLOB stores with historyDepth = 0.
   For such stores file path is calculated without adding a folder for revisions

## [5.5.3] - 2020-11-25
## [5.5.2] - 2020-11-20
### Changed
 - `mdb` BLOB store: if reverseProxy is `nginx` then `getDocument` request for permanently stored items will
   redirect to `sendFileLocationRoot/models` internal location to unify retrieving of models and cmodels.
   
   On the production `cmodels` is located in then `/var/opt/unitybase/..` while models - in the `/opt/unitybase/...`
   Since linkStatic links both to the `inetpub/clientRequire/models`, so better to get all `mdb` items from there.
   
   `ubcli generateNginxCfg` should be executed after upgrade to this version (`ub-app-upgrade` lifecycle script is doing this)
          
## [5.5.1] - 2020-11-19
## [5.5.0] - 2020-11-15
### Added
  - BLOB stores: new `storeSize` `Hourly` - as `Daily` but with sub-folder for each hour inside a day folder
  - BLOB sores: new property `LUCount` - a count of Logical Units BLOB stores divided into.
    If > 0 then files are stored inside `Logical Unit` sub-folders `/LU01`, `/LU02`,.
     
    Write operations works with last LU folder. Each LU folder can be mounted to his own partition.
    In this case `tempPath` should point to the same partition as last LU.
    
## [5.4.17] - 2020-11-14
### Added
 - `@unitybase/blob-stores/storesPerfTest.js` - BLOB store performance testing endpoints implementation.
   See doc inside a `storesPerfTest.js` for usage sample.

## [5.4.16] - 2020-11-12
### Changed
- mdb store now stores MD5

## [5.4.15] - 2020-11-10
## [5.4.14] - 2020-11-08
## [5.4.13] - 2020-11-08
## [5.4.12] - 2020-11-05
### Fixed
- MdbBlobStore do not throw an error on deletion

## [5.4.11] - 2020-11-01
### Added
  - `App.blobStores.getContentPath` method - retrieve full path to a file with BLOB content (in case store is file-based)

## [5.4.10] - 2020-10-15
## [5.4.9] - 2020-09-23
## [5.4.8] - 2020-09-22
### Fixed
- Allow `getDocument` endpoint calls with specific "revision" parameter for "Document" attributes,
  which does not have current value. 

## [5.4.7] - 2020-09-20
## [5.4.6] - 2020-09-01
## [5.4.5] - 2020-08-31
## [5.4.4] - 2020-08-19
## [5.4.3] - 2020-08-19
## [5.4.2] - 2020-07-26
## [5.4.1] - 2020-07-19
## [5.4.0] - 2020-07-15
### Fixed
 - for attributes of "Document" type if store name is empty then name of the default store MUST be written to DB instead
 of empty string. This allows to add another `default` store (mounted to another fs for example) and access documents
 from previous store definition. Fixed regression introduced in UB 4.  

## [5.3.3] - 2020-07-08
### Changed
 - ESLint warnings resolved (no functional changes)
 
## [5.3.2] - 2020-07-01
## [5.3.1] - 2020-06-30
## [5.3.0] - 2020-06-15
### Fixed
 - FileSystem BLOB store - fix incorrect folder names for Monthly & Daily
    - month numeration now starts from 01 (instead 00)
    - day folder name generated as "day of month" (01, 02, .., 31) instead a "day of week" (01, 02, .., 07)

## [5.2.10] - 2020-06-14
## [5.2.9] - 2020-05-25
## [5.2.8] - 2020-05-22
## [5.2.7] - 2020-05-13
## [5.2.6] - 2020-04-24
## [5.2.5] - 2020-04-10
## [5.2.4] - 2020-03-20
## [5.2.3] - 2020-03-17
## [5.2.2] - 2020-03-09
## [5.2.1] - 2020-03-04
## [5.2.0] - 2020-02-29
## [5.1.13] - 2020-02-10
## [5.1.12] - 2020-02-08
## [5.1.11] - 2020-02-03
## [5.1.10] - 2020-01-31
## [5.1.9] - 2020-01-17
## [5.1.8] - 2020-01-11
## [5.1.7] - 2019-12-27
### Changed
  - `FileSystemBlobStore.saveContentToTempStore` will return a real file md5 instead of empty string.
  This allows preventing downloads of the same file several times.

## [5.1.2] - 2019-11-19
### Fixed
 - prevent exposing of package to client by adding `"config": {"ubmodel": {} }` into package.json
 
## [5.1.0] - 2019-10-14
### Fixed
 - BlobStores regression: for stores filled by UB < 5 (without {v: 1,..} attribute in blobStore content JSON)
 default revision should be 0 instead of 1. The content below 
 ```
{"store":"simple","fName":"my file 3000006327362","origName":"","relPath":"","ct":"application/pdf","size":170326,"md5":".."}
 ```
resolved to `pathToSimpleStore/my file 3000006327362/0.pdf` instead of `.../1.pdf`
  
   

## [5.0.39] - 2019-03-19
### Fixed
 - on `nix` replace possible Windows separator inside blob store info `relPath`
 during calculation of Permanent File Name
 
## [5.0.36] - 2019-02-27
### Added
 - new method `blobStore.writeDocumentToResp` to respond to a parsed Document request

## [5.0.34] - 2019-01-30
### Fixed
 - file name in Content-Disposition header should be wrapped in "", in other case comma or other
 not allowed chars in file name can cause Chrome 72 to stop HTTP request)

## [5.0.29] - 2018-12-07
### Added
 - `setDocument` endpoint now can accept a BLOB attribute content as a `base64` encoded string. 
  In this case new parameter `encoding=base64` should be added to setDocument URL.
  Content will be decoded before written to actual storing location.
  
  Also Sync & AsyncConnection's setDocument method is modified to support new parameter.
  
  Feature is useful for clients with limited binary (arrayBuffer) functionality, such as **React Native** 

## [5.0.23] - 2018-11-01
### Added
 - `getDocument` endpoint will put error to log in case user don't have ELS rights
 for requested entity `select` method

## [5.0.23] - 2018-11-01
### Fixed
 -  historical BLOB stores will try to estimate revision number using select from ub_blobHistory in case previous
 BLOB store content is clean (use clear content for example).
 Previous implementation set the revision to `1` and if such revision already exists
 database on `ub_blobHistory` constraint fails.
   
## [5.0.22] - 2018-10-12
### Fixed
 - **SECURITY** `getDocument` endpoint will check user have ELS right to entity `select` method before getting document ID.
 Without this patch in case entity do not use RLS unauthorized access to document is possible
 - for file system based BLOB stores `setDocument` will throw error in case no disk space left
 and remove corrupted temp file. The previous implementation could create zero-length 
 or corrupted files without any exception.

## [5.0.12] - 2018-08-03
### Changed
- file system based BLOB store will use default tempPath: `path.join(this.path, '_temp')` to prevent a
 situation from [unitybase/ub-server#11]

## [5.0.6] - 2018-06-23
### Fixed
- fix exception during saving cleaned Document type attribute value for historical stores (ub-server #10)
