# Change Log
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/)
and this project adheres to [Semantic Versioning](http://semver.org/).

## [Unreleased]
### Added

### Changed

### Deprecated

### Removed

### Fixed

## [5.23.46] - 2023-04-04
### Changed
 - ignore validation of `cdn.organization.accessAddGovByRoles` ubs_settings key for superuser`s

## [5.23.45] - 2023-03-11
## [5.23.44] - 2023-03-10
### Added
 - added ELS rule `CND_FTS_USERS` for `cdn*.fts` - allow full text search for CDN model entities for any user

## [5.23.43] - 2023-03-08
## [5.23.42] - 2023-03-01
## [5.23.41] - 2023-02-22
## [5.23.40] - 2023-02-15
## [5.23.39] - 2023-02-10
## [5.23.38] - 2023-02-06
## [5.23.37] - 2023-01-30
## [5.23.36] - 2023-01-21
### Changed
 - ELS rules for CDN model (cnd*.select for User) moved from CSVs in _initialData into migration YMLs,
  so will be applied during `ubcli migrate`

 - enums for CDN model moved from CSVs in _initialData into migration YMLs, so will be applied during `ubcli migrate`

## [5.23.35] - 2023-01-11
## [5.23.34] - 2022-12-26
### Changed
- Azerbaijani (az) localization

## [5.23.33] - 2022-12-20
## [5.23.32] - 2022-12-14
### Added
 - new `cdn_bank.syncWithNBU` method to add missed Ukrainian banks from service,
   provided by National Bank Of Ukraine 

### Changed
 - decrease top padding of Person/Employee/Department/Organization forms by use new `u-form-layout--on_top` modifier for `u-form-layout`

## [5.23.31] - 2022-12-01
## [5.23.30] - 2022-12-01
## [5.23.29] - 2022-11-24
## [5.23.28] - 2022-11-16
### Removed
- `_initialData/*_call_migrate.js` is removed - `ubcli initialize` call migrate programmatically

## [5.23.27] - 2022-11-09
### Fixed
 - cdn_country migration added in 5.23.24 will skip new counties insertion on fails - most likely dictionary is edited by hands

## [5.23.26] - 2022-11-08
### Fixed
 - fix unsuccessful cdn_country migration by updating code = symbol3 before adding new countries, because 
   some customers have code column equal to ID

## [5.23.25] - 2022-11-08
## [5.23.24] - 2022-11-03
### Changed
- `cdn_currency.setDescriptionAttribute` - removing empty description attribute for prevent duplication attributes on insert
- `cdn_country` - updated dictionary with new countries and phone codes

## [5.23.23] - 2022-10-21
## [5.23.22] - 2022-10-13
## [5.23.21] - 2022-10-13
## [5.23.20] - 2022-10-04
## [5.23.19] - 2022-09-30
## [5.23.18] - 2022-09-26
## [5.23.17] - 2022-09-11
## [5.23.16] - 2022-08-26
### Fixed
- `cdn_contact` and `cdn_classifieritem` forms - show required fields on form to prevent errors when creating new records via entity table
- fix orderList in some system dictionaries

## [5.23.15] - 2022-08-23
## [5.23.14] - 2022-08-19
### Changed
- `org_organization` - attribute `OKPOCode` set as not unique (`isUnique`: false) to prevent errors with duplicated values 
   in environments with non-required CCEO codes

## [5.23.13] - 2022-08-16
### Fixed
- minor localization fixes

## [5.23.12] - 2022-08-09
## [5.23.11] - 2022-08-05
## [5.23.10] - 2022-08-04
### Added
- Added captionSingular for all *.meta and *.meta.lang

### Removed
- for attributes of type `Boolean` removed `allowNull: false` and `defaultValue` - not needed anymore

## [5.23.9] - 2022-07-28
## [5.23.8] - 2022-07-26
## [5.23.7] - 2022-07-26
## [5.23.6] - 2022-07-21
## [5.23.5] - 2022-07-12
## [5.23.4] - 2022-07-11
### Fixed
- `city`, `classifier`, `department`, `employee`, `organization`, `person`, `region` forms:
  - mode v-loading directive above the toolbar, so all form content will be locked while loading
  - prevent locking of all opened forms by use `v-loading` instead of `v-loading.body`

## [5.23.3] - 2022-07-05
### Fixed
- Give the "Developer" role full access to the `cdn_classifier` entity 

## [5.23.2] - 2022-06-19
## [5.23.1] - 2022-06-19
### Added
- ELS full access to CDN for DataManager

## [5.23.0] - 2022-06-15
### Changed
- Move localization for navigation shortcuts and desktop to json files

## [5.22.21] - 2022-06-06
## [5.22.20] - 2022-06-01
## [5.22.19] - 2022-05-26
## [5.22.18] - 2022-05-22
## [5.22.17] - 2022-05-10
### Added
 - added Deutsch (`de`) locale translations

## [5.22.16] - 2022-05-04
## [5.22.15] - 2022-04-29
## [5.22.14] - 2022-04-27
## [5.22.13] - 2022-04-25
### Changed
- Removed some `ub-migrate` warnings by removing obsolete method usages in custom yml formats.

## [5.22.12] - 2022-04-20
## [5.22.11] - 2022-04-20
## [5.22.10] - 2022-04-20
## [5.22.9] - 2022-04-19
### Added
 - added Deutsch (`de`) locale (stub for a while)

## [5.22.8] - 2022-04-14
## [5.22.7] - 2022-04-08
## [5.22.6] - 2022-03-29
### Fixed
- Remove warnings generated by `ub-migrate`

## [5.22.5] - 2022-03-25
## [5.22.4] - 2022-02-16
## [5.22.3] - 2022-02-08
### Added
 - `cdn_organization.OKPOCode` will be trimmed during insert/update operation (prevents unwonted whitespaces remove whitespaces at start/end)

## [5.22.2] - 2022-01-24
### Changed
 - attribute `cdn_person.photo` uses `avatars` BLOB store instead of default to store a person photo.
   Previously uploaded photos still be available from default store.

## [5.22.1] - 2022-01-14
## [5.22.0] - 2022-01-09
## [5.20.37] - 2021-12-14
## [5.20.36] - 2021-12-07
## [5.20.35] - 2021-12-07
## [5.20.34] - 2021-12-06
### Added
 - shortcut for `cdn_profession` added into "Common dictionaries" -> "Miscellaneous" folder 

## [5.20.33] - 2021-12-02
## [5.20.32] - 2021-11-30
## [5.20.31] - 2021-11-23
## [5.20.30] - 2021-11-14
## [5.20.29] - 2021-11-05
### Removed
 - `cdn_person.identCard` (Person's identity card) - removed multi-language support for attribute (does not make sense)
  
## [5.20.28] - 2021-10-27
## [5.20.27] - 2021-10-18
### Added
 - Azerbaijani (az) localization for items with omitted translation

### Changed
 - Navigation shortcuts localization are taken from i18n (from entities caption)
 - English (en) localization for desktop description: the words are capitalized
  according to English rules for captions

## [5.20.26] - 2021-09-24
## [5.20.25] - 2021-09-16
### Changed
- English (en) localization for desktop/shortcut captions: the words are
  capitalized according to English rules for captions
- navigation definition is moved from `_initialData` scripts to `03_navigation.yml`
  file in order to use `ub-migrate` for migration of the navigation data

## [5.20.24] - 2021-09-08
## [5.20.23] - 2021-09-02
## [5.20.22] - 2021-08-31
### Changed
 - Dutch localization correction

## [5.20.21] - 2021-08-18
## [5.20.20] - 2021-08-09
## [5.20.19] - 2021-08-04
## [5.20.18] - 2021-07-18
### Added
 - Dutch (nl) localization

## [5.20.17] - 2021-07-08
## [5.20.16] - 2021-06-14
## [5.20.15] - 2021-05-24
## [5.20.14] - 2021-05-13
## [5.20.13] - 2021-05-07
## [5.20.12] - 2021-05-05
## [5.20.11] - 2021-04-24
## [5.20.10] - 2021-04-23
## [5.20.9] - 2021-04-22
## [5.20.8] - 2021-04-19
## [5.20.7] - 2021-04-19
## [5.20.6] - 2021-04-16
## [5.20.5] - 2021-04-13
## [5.20.4] - 2021-04-02
## [5.20.3] - 2021-04-01
## [5.20.2] - 2021-03-30
## [5.20.1] - 2021-03-29
## [5.20.0] - 2021-03-25
### Changed
- `cdn_classifier` entity uses the `ubm_query` as unity entity

## [5.19.10] - 2021-03-23
## [5.19.9] - 2021-03-17
## [5.19.8] - 2021-03-16
## [5.19.7] - 2021-03-15
## [5.19.6] - 2021-03-15
### Changed
 - CDN forms, reports and er-diagrams are converted to `ubrow` format

## [5.19.5] - 2021-03-03
### Changed
 - client side locales reformatted into JSON
 
### Fixed
- copy classifier item on the form of classifier

## [5.19.4] - 2021-02-25
### Added
 - new attribute `cdn_organization.countryID`

## [5.19.3] - 2021-02-10
## [5.19.2] - 2021-02-08
## [5.19.1] - 2021-02-03
## [5.19.0] - 2021-02-02
## [5.4.67] - 2021-01-30
## [5.4.66] - 2021-01-28
## [5.4.65] - 2021-01-26
## [5.4.64] - 2021-01-19
## [5.4.63] - 2021-01-17
## [5.4.62] - 2021-01-11
## [5.4.61] - 2020-12-30
## [5.4.60] - 2020-12-28
### Fixed
 - Classifier item: add `mi_deleteDate` to unique index to account for safe delete and fix bug
  when user cannot insert item with code equal to one of the deleted item
 - `cdn_organization` - fixed `Invalid JSON` error when updating an `Organization type` for existed organization.
   (introduced in 5.4.49 by isGovAuthority fix) [UBDF-12903]

## [5.4.59] - 2020-12-22
## [5.4.58] - 2020-12-21
## [5.4.57] - 2020-12-20
## [5.4.56] - 2020-12-17
## [5.4.55] - 2020-12-16
## [5.4.54] - 2020-12-14
## [5.4.53] - 2020-12-09
## [5.4.52] - 2020-12-09
## [5.4.51] - 2020-12-02
### Changed
 - `cdn_person form`: make inputs adaptive to form width

### Fixed
- `cdn_employee.meta.uk`: typo in 'middleNameGen', 'middleNameDat', 'fullFIO', 'middleName'
- `cdn_person.meta.uk`: typo in 'middleNameGen', 'middleNameDat', 'classID', 'middleName'

## [5.4.50] - 2020-11-25
## [5.4.49] - 2020-11-23
### Fixed
  - `cdn_organization` - deny ANY update for organizations with government organization type (`orgBusinessTypeID.isGovAuthority=true`)
   by roles not in `cdn.organization.accessAddGovByRoles` list.
   
   Before this fix updating was possible if `orgBusinessTypeID` is not changed. Also, was possible to change an org type from
   government to non-government.

## [5.4.48] - 2020-11-20
## [5.4.47] - 2020-11-19
## [5.4.46] - 2020-11-15
## [5.4.45] - 2020-11-14
## [5.4.44] - 2020-11-12
## [5.4.43] - 2020-11-10
### Changed
- `cdn_profession.meta`: added `defaultView: false` for attribute `description`

### Removed
-`cdn_profession-fm.def`: better to use autoform

## [5.4.42] - 2020-11-08
## [5.4.41] - 2020-11-08
## [5.4.40] - 2020-11-05
## [5.4.39] - 2020-11-01
### Fixed
- `cdn_contact-fm.vue`: fixed form opening without parentContext [UBDF-12453]

## [5.4.38] - 2020-10-20
### Added
 - added DB index by cdn_organization.name
    
## [5.4.37] - 2020-10-15
## [5.4.36] - 2020-09-23
## [5.4.35] - 2020-09-22
## [5.4.34] - 2020-09-21
## [5.4.33] - 2020-09-20
## [5.4.32] - 2020-09-08
## [5.4.31] - 2020-09-01
## [5.4.30] - 2020-08-31
## [5.4.29] - 2020-08-19
## [5.4.28] - 2020-08-19
### Added
 - Tajik locale translation
## [5.4.27] - 2020-08-03
### Added
 - `cdn_orgaccount`: added complex unique index on `(code, currencyID, bankID)`

### Fixed
 - `cdn_orgaccount`: change cache type to "None" since row count can be huge
 - `cdn_orgaccount`: fix error during updating of account with currencyID===null 

## [5.4.26] - 2020-07-29
### Fixed
 - `cdn_orgaccount`: allow `null` for `currencyID` attribute (milty-currency accounts)
 - `cdn_orgaccount`: added default value for `acctype` = `CORR`
 
## [5.4.25] - 2020-07-28
## [5.4.24] - 2020-07-26
## [5.4.23] - 2020-07-19
## [5.4.22] - 2020-07-16
## [5.4.21] - 2020-07-15
## [5.4.20] - 2020-07-08
### Removed
 - unused csv data `cdn_bank.csv`, `cdn_deptype.csv`, `cdn_orgbusinesstype.csv`, `cdn_orgownershiptype.csv`, `cdn_staffunittype.csv`
 are deleted
 
## [5.4.19] - 2020-07-01
## [5.4.18] - 2020-06-30
### Changed
 - ub-migrate `_data` formats.js changed to use export function  

## [5.4.17] - 2020-06-24
## [5.4.16] - 2020-06-21
## [5.4.15] - 2020-06-15
## [5.4.14] - 2020-06-15
## [5.4.13] - 2020-06-14
## [5.4.12] - 2020-05-25
## [5.4.11] - 2020-05-22
## [5.4.10] - 2020-05-17
### Changed
 - replace most font-awesome and element-ui to UB icons analog
  
## [5.4.9] - 2020-05-13
## [5.4.8] - 2020-05-06
## [5.4.7] - 2020-04-24
## [5.4.6] - 2020-04-10
## [5.4.5] - 2020-03-30
### Added
- `cdn_classifier`: added new attribute `orderByAttr` for sorting classifiers items

## [5.4.4] - 2020-03-20
## [5.4.3] - 2020-03-17
### Fixed
- cdn_person, fixed EN word "sufix" to "suffix"

## [5.4.2] - 2020-03-09
## [5.4.1] - 2020-03-04
## [5.4.0] - 2020-02-29
### Changed
 - entities localization files (*.meta.??) are moved to `meta_locale` folder

## [5.3.38] - 2020-02-23
### Changed
 - currency dictionary shortcut - decrease `code` and `code3` column width
 - `cdn_orgaccount.bank` marked as **allow null** - IBAN account code already contains bank MFO, so having bank here is not necessary
 - optimization of account description calculation:
 in case bank/currency entity is updated but attributes bank.name/currency.code3 is not changed we do nt need to update accounts descriptions  
 
## [5.3.37] - 2020-02-18
## [5.3.36] - 2020-02-13
## [5.3.35] - 2020-02-10
## [5.3.34] - 2020-02-08
### Removed
  - `cdn_organization.csv` sample data is removed from CDN package

### Fixed
 - cdn_classifier form: prevent error with "undefined" classifierID in items parentEntity combobox  

## [5.3.33] - 2020-02-03
## [5.3.32] - 2020-01-31
## [5.3.31] - 2020-01-17
### Added
 - `cdn_employee-fm` form rewritten to Vue
 - `cdn_department-fm` form rewritten to Vue
 - `cdn_organization-fm` form rewritten to Vue
 - `cdn_person-fm` form rewritten to Vue
 - `cdn_contact-fm` form rewritten to Vue
 - `cdn_classifier-fm` form rewritten to Vue
 - `cdn_classifieritem-fm` form rewritten to Vue
 - `beforeAddNew`, `contactsRepository` mixins

### Changed
 - renamed 'Sex' to 'Gender', added full gender name to 'CDN_SEXTYPE' enum
 - renamed 'Sex' to 'Gender', added full gender name to 'CDN_SEXTYPE'
 - `cdn_organization` 'OKPOcode' field is required
 - rewrote `010_create_navshortcuts.js` config for rendering cdn forms on vue

### Fixed
 - cdn_classifieritem - fix error about non-existed attribute usage inside insert/update
 - cdn_classifieritem - fix uniqueness constraint for code attribute, not code is unique inside classifier, not globally
  
## [5.3.30] - 2020-01-11
## [5.3.29] - 2020-01-03
## [5.3.28] - 2020-01-02
## [5.3.27] - 2019-12-30
## [5.3.26] - 2019-12-27
### Added
  - description for 'Common dictionary' desktop (+localization)

## [5.3.25] - 2019-12-20
## [5.3.24] - 2019-12-18
### Fixed
 - Russian language name in initial data for "ru" and "tg"

## [5.3.23] - 2019-12-17

## [5.3.19] - 2019-12-11
### Added
 - navigation shortcuts for Banks and Streets
  
## [5.3.17] - 2019-12-04
### Changed
  - **BREAKING!!!** Classifiers entities renamed, all over the code (navigation, etc)
    - `cdn_classifiertype` => `cdn_classifier`
    - `cdn_classifier` => `cdn_classifieritem`
  - Renamed `title` to `name` for both entities
  - Made `cdn_classifier.name` and `cdn_classifier.description` attributes multi-language
  - Remove `stateCode` from `cdn_classifier` as a bit too specific to be in generic dictionary. 
    If you need this (or any other) attribute, either request a JSON attribute in this dictionary or use entity override
    feature for your project.
  - Add format description for classifiers for ub-migrate (the _date/formats.js).

## [5.3.7] - 2019-12-02
### Added
  - synchronization of the user's email with the employee's contact

## [5.3.6] - 2019-10-01
### Changed
  - colon separator for cdn_region uk locale csv data to ';' as in all other files  

## [5.3.3] - 2019-09-19
### Fixed
 - explicitly specified fieldList for cdn_employee & cdn_person shortcuts to prevent lookup on potentially huge cdn_organization 

## [5.3.1] - 2019-09-17
### Fixed
 - Field 'level' renamed to 'hierarchyLevel' because 'level' is a reserved word in Oracle - so this field breaks ddl generation for Oracle database
 - Forms for entering classifiers were missing

## [5.3.0] - 2019-09-16
### Added
 - cdn_classifier & cdn_classifierType - entities that provide ability to user to classify some entity in many ways, this is like user defined expandable dictionaries
 - cdn_language - list of languages according to ISO-639-1

## [5.2.12] - 2019-09-11
### Changed
 - cdn_currency.name size to 65 and cdn_currency.description size to 128

## [5.2.5] - 2019-08-12
### Changed
 - initial data locale for cdn_citytype & cdn_country entities changed to english
 - initial data for cdn_region loaded only for `uk` locale  

## [5.2.0] - 2019-07-22
### Changed
 - all meta files and they localization transformed to array-of-attributes format
  
## [5.1.17] - 2019-06-12
### Changed
 - `Subjects` folder icon changed to `fa fa-user-circle-o` to prevent conflict with `Territorial` icon

## [5.1.15] - 2019-06-10
### Changed
 - cdn_orgaccount code length changed 20 -> 29  
 
## [5.1.5] - 2019-03-11
### Changed
 - File cnd_person.meta.ka fixed

## [5.1.0] - 2019-01-10
### Added
 - new cdn dictionaries: cdn_nationality, cdn_personclass
 - new attribute of cdn_person: resident: boolean; nationality -> cdn_nationality, classID -> cdn_personclass
### Changed
 - Description attribute of cdn_currency is now multilingual
 
## [5.0.73] - 2018-12-06
### Changed
 - restriction for CCEO (OKPO) length (8 or 10 chars) is removed from `cdn_organization`

## [5.0.66] - 2018-11-17
### Changed
 - cdn_city: allow to select Country as a parent admin unit for city (filter on the form)
 - cdn_region: allow to select any admin unit as a region parent (in prev implementation
 select was limited by COUNTRY). See #19 for changes reasons
  
## [5.0.52] - 2018-09-19
### Fixed
- cdn_bank formation of the description when the constituent attributes were deleted

## [5.0.28] - 2018-07-16
### Changed
- cdn_region form marked as isDefault: false to allow override by other models

## [5.0.6] - 2018-05-04
### Changed
 - default meta file localization is english
 - entities attributes definitions transformed to array-of-object as described in entity JSON schema

## [4.0.48] - 2018-01-04
### Changed
- initial data for `cdn_currency` updated to actual currencies list

## [4.0.47] - 2017-12-12
### Added
- `cdn_bank` `cityID` and `description` attributes
- `cdn_currency` `curMult` attributes (Default multiplicity)

### Changed
- localization for cdn_orgaccount
