module.exports = migrate

/**
 * Update code = symbol3 before adding new countries (010_afterDDL_add_phone_codes.js), because
 * some customers have code column equal to ID
 *
 * @param {object} params
 * @param {SyncConnection} params.conn
 */
function migrate ({ conn }) {
  const countries = conn.Repository('cdn_country').attrs('ID', 'code', 'symbol3', 'mi_modifyDate').selectAsObject()
  countries.forEach(c => {
    if (c.code !== c.symbol3) {
      conn.update({
        entity: 'cdn_country',
        execParams: {
          ID: c.ID,
          code: c.symbol3,
          mi_modifyDate: c.mi_modifyDate
        }
      })
    }
  })
}
