# LogView - UI for viewing and analysing a UnityBase logs

Access to logs are enabled for members of `SysOps` and `Developer` roles using `Administration -> Maintaince tools -> Log Viewer` shortcut

Can open either local `*.log` files, or access remote server logs (for revere proxy configuration see below)

Limitations:
  - currently recognize only file logs with lines like `20210727 08260932  $ SQL`, 
 journald and docker logs will be added ASAP
  - for remote logs `follow` mode is enabled only if UB is behind nginx (Range: header support required)

# Setup
Add package to application and model into ubConfig domain

```shell
npm i @unitybase/logview
```

ubConfig.json:
```json5
{
  "application": {
    "domain": {
      "models": [
        //....
        {
          "path": "./node_modules/@unitybase/logview"
        }
        // ....  
      ]
    }
  }
}
```

# For accessing remote logs (can be omitted to open local files)
If `reverseProxy` is enabled, to access a remote logs create a [drop-in for nginx](https://unitybase.info/api/server-v5/tutorial-reverse_proxy_nginx.html#extending-autogenerated-config)
with `remoteLog` internal location: 
  - `my-server-com`  must be replaced with real `externalURL` with `.` replaced by `-`
  - `/full/path/to/logs` - with `logging.path` from ubConfig

```shell
mkdir -p /var/opt/unitybase/shared/my-server-com
cat <<<EOF
location /my-server-com/remoteLog {
    internal;
    expires -1;
    add_header Cache-Control "must-revalidate, private";
    add_header 'Access-Control-Allow-Origin' "$http_origin" always;
    alias /full/path/to/logs;
}
EOF > /var/opt/unitybase/shared/my-server-com/server-romoleLogAccess.conf
```

> in next releases we implement remoteLog location generation in `ubcli generateNginxCfg`
