# UDISK 
## Общее описание.
Предназначен для организации доступа к общим файлам с разделением по папкам и ограничением прав доступа. 
Также есть возможность доступа к файлам через WebDAV.

Файлы могут быть добавлены в диск "перетаскиванием" (drag and drop) из проводника, а также через интерфейс
выбора файлов по кнопке "Добавить файлы". Диск содержит (хранит) файлы и папки (далее элементы диска).

Каждая папка может содержать любые элементы. В рамках диска поддерживаются операции копирования и перемещения.
Файлы диска могут быть заблокированы пользователем. Заблокированный файл удалить или изменить содержимое может
только тот пользователь, который его заблокировал.

## Интерфейс (кратко)
В верхней части находится меню с панелью поиска и панель показывающая текущий путь.
В центре перечень файлов и папок содержащиеся по этому пути.

По двойному клику на папку «проваливаемся» на уровень этой папки. Для возврата на уровень выше надо нажать
соответствующее название папки в панели, содержащей текущий путь.

По двойному клику на файле открываестя окно свойств. В окне свойств выводятся атрибуты файла и либо содержимое файла, если это возможно,
либо ссылка на него. В этой же форме можно заблокировать документ.

В контекстном меню по нажатию кнопки «Права» открывается форма настройки прав доступа (описать).
Поиск производится по названиям элементов диска.

Для администрирования дискa есть специальные интерфейсы. Доступ к ним имеют только пользователи с ролью
администратор диска. В этом интерфейсе видны все элементы диска. Администратор может назначить права на любой элемент.

Посмотреть содержимое файлов или выгрузить его можно толко при наличии соответсвующих прав.
Параметры ярлыка для основного интерфейса
```
{  
   "cmdType":"showForm",
   "formCode":"udisk_card",
   "entity":"udisk_card",
   "cmpInitConfig":{  
      "treeHidden":false
   }
}
```
Для  администратора

```
{  
   "cmdType":"showForm",
   "formCode":"udisk_card",
   "entity":"udisk_card",
   "description":"UDISK admin interface",
   "cmpInitConfig":{  
      "mode":"admin"
   }
}
```

Где treeHidden : false указывает показать дерево папок. (По умолчанию спрятано)
entity – сущность диска (описаны в разделе прав) 

Настройка шаблонов новых документов
Позволяет настроить шаблоны новых документов. Эти документы появятся в меню «добавить» интерфейса
  Добавить в файл конфигурации сервера опцию 	

```
  "uiSettings":{  
      "adminUI":{  
         "udiscFileTemplates":"models/udisk/fileTemplates"
      }
   }
```
 
В папке на которую указывает udiscFileTemplates должен быть файл 
[Entity name].JSON на пример udisk_card.JSON
В этом файле можно указать шаблоны файлов.
```
[  
   {  
      "name":"new word document",
      "fileName":"new word document.docx",
      "path":"models/udisk/fileTemplates/word.docx"
   }
]
```
Где 
 - Name – название для меню
 - fileName – Название нового файла
 - path – Путь к шаблону Путь для клиента относительно хоста.
 
 Для указанного примера не забудьте, что в модели для клиента доступна только папка public.
 На диске это будет `%ub_home%/UnityBase/models/udisk/public/fileTemplates/word.docx`

## Права доступа
 Разделяются на уровни доступа:
   - Чтение 
   - Запись
   - Редактирование
   - Владелец

 Наибольший приоритет у уровня "Владелец" наименьший "Чтение".
 
 Права уровня "Владелец" могут быть только у одного пользователя (не роли).
 Права доступа назначаются как пользователям, так и ролям. Каждый элемент диска имеет свои права.
 
 Доступ на чтение к корневой папке диска имеют все пользователи. Создавать файлы и папки в корневой 
 папке диска могут только пользователи с ролью администратор диска.
 
 Создатель элемента диска автоматически становиться ее владельцем. Редактировать права доступа могут только
 пользователи, имеющие уровень доступа "Владелец" или "Делегирование".
 
 Создавать, редактировать и удалять элементы могут пользователи с уровнем доступа "Запись".
 
 Пользователи с правом доступа "Чтение" могут просматривать содержимое папок и файлов. Если пользователь не имеет
 прав на чтение, то он не увидит файл в списке. 
 
 Файлы наследуют права доступа содержащих их папок. Наследуемые права нельзя удалить.  Папки никогда 
 не наследуют права доступа и требуют индивидуальной настройки прав доступа.

При копировании элементов диска, права доступа не копируются. При перемещении элементов права доступа сохраняются.
Доступ к элементам диска могут получить только пользователи, которым доступна папка содержащая их. 

Всего есть три диска: Открытый, служебный, секретный

Соответственно сущности: udisk_card, udisk_servicecard, udisk_secretcard

Данные дисков хранятся в отдельных хранилищах
  -	Oткрытый диск: `udiskStore`
  - Служебный диск - `udiskStoreService`
  - Секретный диск - `udiskStoreSecret`
  
Открытый и служебный диски одинаковые и соответствуют выше описанным правам доступа.
У секретного диска есть ряд особенностей:
 - Нет права доступа Owner. Соответственно при создании папки или файла автор получает права Write. 
 - Нет права доступа Delegate. Назначать права может только администратор диска
 
Роли в системе:
- Oткрытый диск
  - `udiskPublicUsers` – пользователь диска
  - `udiskPublicAdmins` – администратор диска
  - `udiskPublicAdminsDenyContent` – адимин с запретом использовать диск
- Служебный диск
  - `udiskServiceUsers` – пользователь диска
  - `udiskServiceAdmins` – администратор диска
  - `udiskServiceAdminsDenyContent` – адимин с запретом использовать диск

- Секретный диск
  - `udiskSecretUsers` – пользователь диска
  - `udiskSecretAdmins` – администратор диска
  - `udiskSecretAdminsDenyContent` – адимин с запретом использовать диск


## WebDav
На данный момент открыть для редактирования можно только файлы Microsoft office.
Для работы с  WebDav необходимо использовать авторизацию по домену.

Документ, открытый при помощи «WebDav», автоматически блокируется. Если связь с открытым документом 
по каким-то причинам теряется, блокировка сохраняется. 

## Архитектура
Ярлыки файлов и папок, их атрибуты и права доступа хранятся в базе данных. Содержимое файлов хранится в хранилище.
Права доступа ограничиваются на уровне сервера. 

## Partial and environment variables

Model partial config adds `application.blobStores` section witch adds 3 BLOB stores:
  - %UB_APPDATA%stores/udisk/
  - %UB_APPDATA%stores/udisksecret/
  - %UB_APPDATA%stores/udiskpservice/

